import { invariant } from "outvariant";
function bypass(input, init) {
  const request = input instanceof Request ? input : new Request(input, init);
  invariant(
    !request.bodyUsed,
    'Failed to create a bypassed request to "%s %s": given request instance already has its body read. Make sure to clone the intercepted request if you wish to read its body before bypassing it.',
    request.method,
    request.url
  );
  const requestClone = request.clone();
  requestClone.headers.set("x-msw-intention", "bypass");
  return requestClone;
}
export {
  bypass
};
//# sourceMappingURL=bypass.mjs.map