"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var WebSocketHandler_exports = {};
__export(WebSocketHandler_exports, {
  WebSocketHandler: () => WebSocketHandler,
  kDefaultPrevented: () => kDefaultPrevented,
  kDispatchEvent: () => kDispatchEvent,
  kEmitter: () => kEmitter
});
module.exports = __toCommonJS(WebSocketHandler_exports);
var import_strict_event_emitter = require("strict-event-emitter");
var import_matchRequestUrl = require("../utils/matching/matchRequestUrl.js");
const kEmitter = Symbol("kEmitter");
const kDispatchEvent = Symbol("kDispatchEvent");
const kDefaultPrevented = Symbol("kDefaultPrevented");
class WebSocketHandler {
  constructor(url) {
    this.url = url;
    this[kEmitter] = new import_strict_event_emitter.Emitter();
  }
  [kEmitter];
  parse(args) {
    const connection = args.event.data;
    const match = (0, import_matchRequestUrl.matchRequestUrl)(connection.client.url, this.url);
    return {
      match
    };
  }
  predicate(args) {
    return args.parsedResult.match.matches;
  }
  async [kDispatchEvent](event) {
    const parsedResult = this.parse({ event });
    const shouldIntercept = this.predicate({ event, parsedResult });
    if (!shouldIntercept) {
      return;
    }
    if (!Reflect.get(event, kDefaultPrevented)) {
      Reflect.set(event, kDefaultPrevented, true);
    }
    const connection = event.data;
    this[kEmitter].emit("connection", {
      client: connection.client,
      server: connection.server,
      params: parsedResult.match.params || {}
    });
  }
}
//# sourceMappingURL=WebSocketHandler.js.map