"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var handleWebSocketEvent_exports = {};
__export(handleWebSocketEvent_exports, {
  handleWebSocketEvent: () => handleWebSocketEvent
});
module.exports = __toCommonJS(handleWebSocketEvent_exports);
var import_WebSocketHandler = require("../handlers/WebSocketHandler.js");
var import_webSocketInterceptor = require("../ws/webSocketInterceptor.js");
function handleWebSocketEvent(getCurrentHandlers) {
  import_webSocketInterceptor.webSocketInterceptor.on("connection", (connection) => {
    const handlers = getCurrentHandlers();
    const connectionEvent = new MessageEvent("connection", {
      data: connection
      /**
       * @note This message event should be marked as "cancelable"
       * to have its default prevented using "event.preventDefault()".
       * There's a bug in Node.js that breaks the "cancelable" flag.
       * @see https://github.com/nodejs/node/issues/51767
       */
    });
    Object.defineProperty(connectionEvent, import_WebSocketHandler.kDefaultPrevented, {
      enumerable: false,
      writable: true,
      value: false
    });
    for (const handler of handlers) {
      if (handler instanceof import_WebSocketHandler.WebSocketHandler) {
        handler[import_WebSocketHandler.kDispatchEvent](connectionEvent);
      }
    }
    if (!Reflect.get(connectionEvent, import_WebSocketHandler.kDefaultPrevented)) {
      connection.server.connect();
      connection.client.addEventListener("message", (event) => {
        connection.server.send(event.data);
      });
    }
  });
}
//# sourceMappingURL=handleWebSocketEvent.js.map